package satsaapdumidletpackage;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Form;
import java.io.IOException;
import javax.microedition.io.Connector;
import javax.microedition.apdu.APDUConnection; //SATSA APDU API

public class SATSAapduMIDlet extends MIDlet 
implements CommandListener
{
byte[] apdu =
{
//command APDU
//00 F2 00 00 14	
 (byte) 0x00, (byte) 0xF2, (byte) 0x00, (byte) 0x00, 
 (byte) 0x14
};

byte[] response = null;
    
//form object
Form form = new Form("SimpleAPDU");    
	
//exit command object
Command exitCmd = new Command("Exit", 1, Command.OK);
	
//constructor	
public SATSAapduMIDlet() 
  {
super();
  }//constructor

 
protected void startApp() throws MIDletStateChangeException 
{
//add command to form object 
form.addCommand(exitCmd);

//add command listener
form.setCommandListener(this);

//set the display to form object   
Display.getDisplay(this).setCurrent(form);

//initialise connection object
APDUConnection ISO_SM_Conn = null;
	            
try
{
form.append("Comms with Contact SE started....\n");

//construct URL string with Java Card Applet AID 
//AID is 0x59, 0x92, 0x51x 0x6E, 0x83, 0x6D, 0x71, 
0x44, 0x25, 0x64, 0x39, 0x34, 0x90.
String urlSC = 
"apdu:0;target=59.92.51.6E.83.6D.71.44.25.64.39.34.90";

//Create and open a connection object 
ISO_SM_Conn = (APDUConnection)Connector.open(urlSC);

//print the apdu send to form
form.append("Command APDU to Contact SE --->"+ 
convertByteToHexString(apdu) +"\n");
response = null;

//send APDU via exchangeAPDU method
response = ISO_SM_Conn.exchangeAPDU(apdu); 
			        	     
if(response !=null)
{
//Last two bytes define the status of the response 
if (response.length > 2) 
{
//expecting a response of more than 2 bytes long (20 bytes)
//print response to form
form.append("Response APDU from Contact SE <---"+ 
convertByteToHexString(response) +"\n");
}//end of if
else
{
//expecting an error code Status Word
//print response to form
form.append("Response to cmd:\n" + 
convertByteToHexString(response));
}//end of else

response = null;
}
}//end of try
catch(IOException e) 
{
form.append(e.getMessage());
e.printStackTrace();
}//end of catch
finally 
{
if (ISO_SM_Conn != null) 
{
//Close connection
try{
ISO_SM_Conn.close();
}//try
catch(Exception ex)
{
form.append(ex.getMessage());
ex.printStackTrace();
}//catch
}//if
}//finally

}//end of startApp
			
protected void pauseApp() 
{
}//end of pauseApp()

protected void destroyApp(boolean arg0) 
throws MIDletStateChangeException 
{
notifyDestroyed();
}//end of destroyApp

//handle Exit Command
public void commandAction(Command arg0, Displayable arg1) 
{
if(arg0 == exitCmd)
{
 exit();
}//if
}//commandAction

private void exit()
{
 try
  {
  destroyApp(false);
  notifyDestroyed();
  }//try
 catch(MIDletStateChangeException ex)
  {
  }//catch
}//exit()
			
//convert a byte array into hexadecimal string
private static String convertByteToHexString(byte[] data) 
{
StringBuffer sbuff = new StringBuffer();
	        
for (int i = 0; i < data.length; i++) 
{
String bufftemp = Integer.toHexString(data[i] & 0xFF);
       bufftemp = bufftemp.toUpperCase();

if (bufftemp.length() == 1) 
  {
  sbuff.append(0);
  }//end of if
  sbuff.append(bufftemp + " ");
}//end of For

return sbuff.toString();
}//end of convertByteToHexString

}//end of class SATSAapduMIDlet